---
title: MediaRecorder()
slug: Web/API/MediaRecorder/MediaRecorder
tags:
  - API
  - Audio
  - Constructor
  - Media
  - Media Capture
  - Media Recorder API
  - MediaRecorder
  - Reference
  - Video
---
<div>{{APIRef("MediaStream Recording")}}</div>

<p><span class="seoSummary">The <strong><code>MediaRecorder()</code></strong> constructor creates a new {{domxref("MediaRecorder")}} object that will record a specified {{domxref("MediaStream")}}.</span> The object can optionally be configured to record using a specific media container (file type), and, further, can specify the exact codec and codec configuration(s) to use by specifying <a href="/en-US/docs/Web/Media/Formats/codecs_parameter">the <code>codecs</code> parameter</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mediaRecorder</em> = new MediaRecorder(<em>stream</em>[, <em>options</em>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><strong>stream</strong></code></dt>
 <dd>The {{domxref("MediaStream")}} that will be recorded. This source media can come from a stream created using {{domxref("MediaDevices.getUserMedia", "navigator.mediaDevices.getUserMedia()")}} or from an {{HTMLElement("audio")}}, {{HTMLElement("video")}} or {{HTMLElement("canvas")}} element.</dd>
 <dt>
 <p><strong><code>options</code> </strong>{{optional_inline}}</p>
 </dt>
 <dd>
 <p>A dictionary object that can contain the following properties:</p>

 <ul>
  <li><code>mimeType</code>: A MIME type specifying the format for the resulting media; you may specify the container format (the browser will select its preferred codecs for audio and/or video), or you may <a href="/en-US/docs/Web/Media/Formats/codecs_parameter">use the <code>codecs</code> parameter</a> and/or the <code>profiles</code> parameter to provide detailed information about which codecs to use and how to configure them. Applications can check in advance if a <code>mimeType</code> is supported by the {{Glossary("user agent")}} by calling {{domxref("MediaRecorder.isTypeSupported()")}}.</li>
  <li><code>audioBitsPerSecond</code>: The chosen bitrate for the audio component of the media.</li>
  <li><code>videoBitsPerSecond</code>: The chosen bitrate for the video component of the media.</li>
  <li><code>bitsPerSecond</code>: The chosen bitrate for the audio and video components of the media. This can be specified instead of the above two properties. If this is specified along with one or the other of the above properties, this will be used for the one that isn't specified.</li>
 </ul>

 <div class="note">
 <p>If bits per second values are not specified for video and/or audio, the default adopted for video is 2.5Mbps, while the audio default is adaptive, depending upon the sample rate and the number of channels.</p>
 </div>
 </dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>The specified MIME type is not supported by the user agent.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows how to create a media recorder for a specified stream, whose audio bit rate is set to 128 Kbit/sec and whose video bit rate is set to 2.5 Mbit/sec. The recorded media data will be stored in an MP4 wrapper (so if you gather the chunks of media data and save them to disk, they will be in an MP4 file).</p>

<pre class="brush: js">...
if (navigator.mediaDevices.getUserMedia) {
  var constraints = { audio: true, video: true };
  var chunks = [];

  var onSuccess = function(stream) {
    var options = {
      audioBitsPerSecond : 128000,
      videoBitsPerSecond : 2500000,
      mimeType : 'video/mp4'
    }
    var mediaRecorder = new MediaRecorder(stream,options);
    m = mediaRecorder;

...
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("MediaStream Recording")}}</td>
   <td>{{Spec2("MediaStream Recording")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaRecorder.MediaRecorder")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaRecorder_API/Using_the_MediaRecorder_API">Using the MediaRecorder API</a></li>
 <li><a href="https://mdn.github.io/web-dictaphone/">Web Dictaphone</a>: MediaRecorder + getUserMedia + Web Audio API visualization demo, by <a href="https://twitter.com/chrisdavidmills">Chris Mills</a> (<a href="https://github.com/mdn/web-dictaphone/">source on Github</a>.)</li>
 <li><a href="http://simpl.info/mediarecorder/">simpl.info MediaStream Recording demo</a>, by <a href="https://twitter.com/sw12">Sam Dutton</a>.</li>
 <li>{{domxref("Navigator.mediaDevices.getUserMedia()")}}</li>
</ul>
